#include <bits/stdc++.h>
using namespace std;

struct Node{
	int num;
	Node* fa;
	Node* lson, *rson;
}; 
Node* root;
Node* a[100050];

void Insert(int u, int lr, int id) {
	Node* idNode = new Node;
	idNode->num = id;
	idNode->lson = nullptr;
	idNode->rson = nullptr;
	idNode->fa = a[u];
	
	// TODO
	if(lr == 0) {
		a[u]->lson = idNode;
	} else {
		a[u]->rson = idNode;
	}
	a[id] = idNode;
}

void Exchange(int u, int v) {
	bool ulr, vlr; // 0: is lson, 1: is rson
	Node* ufa = a[u]->fa, *vfa = a[v]->fa;
	if(ufa->lson == nullptr) {
		ulr = 1;
	} else if (ufa->lson == a[u]) {
		ulr = 0;
	} else {
		ulr = 1;
	}
	if(vfa->lson == nullptr) {
		vlr = 1;
	} else if (vfa->lson == a[v]) {
		vlr = 0;
	} else {
		vlr = 1;
	}
	
	if(ulr == 0 && vlr == 0) {
		swap(ufa->lson, vfa->lson);
	}
	if(ulr == 0 && vlr == 1) {
		swap(ufa->lson, vfa->rson);
	}
	if(ulr == 1 && vlr == 0) {
		swap(ufa->rson, vfa->lson);
	}
	if(ulr == 1 && vlr == 1) {
		swap(ufa->rson, vfa->rson);
	}
	swap(a[u]->fa, a[v]->fa);
}

void Output(int u) {
	if(a[u]->fa != nullptr) {
		cout << (a[u]->fa->num) <<" ";
	} else {
		cout << "-1 ";
	}
	if(a[u]->lson != nullptr) {
		cout << (a[u]->lson->num) <<" ";
	} else {
		cout << "-1 ";
	}
	if(a[u]->rson != nullptr) {
		cout << (a[u]->rson->num) << endl;
	} else {
		cout << "-1" << endl;
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0); 
	
	int T, r;
	cin >> T >> r;
	
	root = new Node;
	root->fa = nullptr;
	root->lson = nullptr;
	root->rson = nullptr;
	root->num = r;
	a[r] = root;
	
	while(T--) {
		int op;
		cin >> op;
		if(op == 1) {
			int u, lr, id;
			cin >> u >> lr >> id;
			Insert(u, lr, id);
		} else if (op == 2) {
			int u, v;
			cin >> u >> v;
			Exchange(u, v);
		} else if (op == 3) {
			int u;
			cin >> u;
			Output(u);
		}
	}
	return 0;
}
